<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <!-- <v-card-title class="pb-0">
        <h1>
          <b v-if="compra">{{$t('editarRecepcion')}}</b>
          <b v-else>{{$t('nuevaRecepcion')}}</b>
        </h1>
      </v-card-title> -->
      <v-form v-model="valid" ref="recepcionFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="4" md="4" sm="12" class="mt-3">
            <UsuariosBuscador
              @onSeleccionarUsuario=recibeSeleccionado
              :labelSearch="$t('recibidoPor...')"
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12" class="mt-3">
            <UsuariosBuscador
              @onSeleccionarUsuario=entregaSeleccionado
              :labelSearch="$t('entregadoPor...')"
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12">
            <h3 v-if="disabled">
              <span class="success--text">{{ $t('codigoGenerado') }} {{ ' : ' }} {{ codigo }}</span>
            </h3>
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarRecepcion"
            :disabled="disabled"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="terminarRecepcion">
            {{$t('terminar')}}
          </v-btn>
          <v-btn  color="info" rounded @click="imprimir" :disabled="!disabled">
            {{$t('imprimir')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import RecepcionServicio from '@/store/services/RecepcionServicio'
import UsuariosBuscador from '../Usuarios/UsuariosBuscador'
export default {
  name:'RecepcionesForm',
  components: {
    UsuariosBuscador
  },
  props: {
    compra: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: null,
        recibe: '',
        entrega: '',
      },
      rules: {
        isRequired: [value => !!value || this.$t('errorAlCargar')],
      },
      isLoading: false,
      disabled: false,
      codigo: 0
    }
  },
  methods: {
    async guardarRecepcion() {
      try {
        if (this.$refs.recepcionFrom.validate()) {
          var response = ''
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await RecepcionServicio.create(dataForm)
          } else {
            response = await RecepcionServicio.update(this.form.id, this.form)
          }
          this.disabled = true
          this.codigo = response.data.id
          this.$emit('onRecepcionGuardada', response.data)
        }
      } catch (e) {console.log(e)
        if (e.response.status > 300) {
          console.log('error recepcion')
        }
      }
    },
    cancelarGuardar() {
      this.$refs.recepcionFrom.reset()
      this.$emit('onCancelarGuardar',  false);
    },
    setData() {
      if (this.recepcion) {
        this.form.id = this.recepcion.id
        this.form.recibe = this.recepcion.factura
        this.form.entrega = this.recepcion.factura
      }
    },
    resetData() {
      this.form.id = null
      this.form.recibe = ''
      this.form.entrega = ''
      this.codigo = 0
      this.disabled = false
    },
    terminarRecepcion() {
      this.resetData()
      this.$emit('onTerminarRecepcion')
    },
    recibeSeleccionado(value) {
      this.form.recibe = value.id
    },
    entregaSeleccionado(value) {
      this.form.entrega = value.id
    },
    imprimir() {
      this.$emit('onImprimir');
    }
  },
  computed: {

  },
  watch: {
    compra: {
      immediate: true,
      handler() {
        this.setData()
      }
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
